## deepin-fcitx5configtool-plugin 5.0.23

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)

set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
set(CMAKE_DISABLE_SOURCE_CHANGES ON)

if ("${CMAKE_BINARY_DIR}" STREQUAL "${CMAKE_SOURCE_DIR}")
  message(FATAL_ERROR "In-source builds are disabled.
    Please create a subfolder and use `cmake ..` inside it.
    NOTE: cmake will now create CMakeCache.txt and CMakeFiles/*.
          You must delete them, or cmake will refuse to work.")
endif()

project(fcitx5-configtool VERSION 5.1.2)

set(QT_MIN_VERSION "5.12.0")
find_package(ECM 1.0.0 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings)
include(FeatureSummary)
include(ECMSetupVersion)
include(GenerateExportHeader)
option(ENABLE_KCM "Enable KDE Config Module" On)
option(ENABLE_CONFIG_QT "Enable fcitx5-config-qt" On)
option(ENABLE_TEST "Enable test" Off)
add_definitions(-DTRANSLATION_DOMAIN=\"org.fcitx.fcitx5.kcm\")
add_definitions(-DFCITX_GETTEXT_DOMAIN=\"fcitx5-configtool\")
add_definitions(-DQT_NO_KEYWORDS)

find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS Core Gui Widgets X11Extras Concurrent)
find_package(DtkCore REQUIRED)
find_package(DtkWidget REQUIRED)

find_package(KF5ItemViews REQUIRED)

find_package(Fcitx5Core 5.0.4 REQUIRED)
find_package(Fcitx5Config REQUIRED)
find_package(Fcitx5Utils REQUIRED)
find_package(Fcitx5Qt5DBusAddons REQUIRED)
find_package(Fcitx5Qt5WidgetsAddons 5.0.2 REQUIRED)
find_package(Qt5Svg)
set_package_properties(Qt5Svg PROPERTIES
    DESCRIPTION "May be used for show icons"
    TYPE RUNTIME)

get_target_property(FCITX5_QT5_GUI_WRAPPER Fcitx5Qt5::gui-wrapper IMPORTED_LOCATION)

find_package(KF5WidgetsAddons REQUIRED)
find_package(IsoCodes REQUIRED)
kde_enable_exceptions()

include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")

find_package(PkgConfig REQUIRED)
find_package(Gettext REQUIRED)
find_package(X11 REQUIRED)
find_package(XKeyboardConfig REQUIRED)
pkg_check_modules(XkbFile "xkbfile" REQUIRED IMPORTED_TARGET)

set(DEFAULT_XKB_RULES "evdev" CACHE STRING "Xkb rules name")

configure_file(config.h.in config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(layout)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== debian/changelog ===
deepin-fcitx5configtool-plugin (5.0.23) unstable; urgency=medium

  * chore: 特化打开搜狗输入法设置页面方式
    Issues: linuxdeepin/developer-center#10079

 -- zsien <quezhiyong@deepin.org>  Fri, 02 Aug 2024 11:13:09 +0800

deepin-fcitx5configtool-plugin (5.0.22) unstable; urgency=medium

  * chore: 修改打开应用商店的方式 (linuxdeepin/developer-center#8849)

 -- zsien <quezhiyong@deepin.org>  Fri, 07 Jun 2024 14:25:24 +0800

deepin-fcitx5configtool-plugin (5.0.21) unstable; urgency=medium

  * 重构代码
  * 合并最新 fcitx5-configtool
  * fix: elide text

 -- zsien <quezhiyong@deepin.org>  Mon, 15 Apr 2024 13:39:43 +0800

deepin-fcitx5configtool-plugin (5.0.20) unstable; urgency=medium

  * fix: will clear the shortcuts

 -- zsien <quezhiyong@deepin.org>  Fri, 15 Mar 2024 10:34:06 +0800

deepin-fcitx5configtool-plugin (5.0.19) unstable; urgency=medium

  * fix: shortcut of "Scroll bewteen input methods" is wrong

 -- zsien <quezhiyong@deepin.org>  Fri, 01 Mar 2024 13:04:11 +0800

deepin-fcitx5configtool-plugin (5.0.18) unstable; urgency=medium

  * 修复打开高级设置后切换页面控制中心崩溃
  * fix build errors
  * fix setting shortcut failed
  * update translations

 -- zsien <quezhiyong@deepin.org>  Thu, 28 Dec 2023 10:32:42 +0800

deepin-fcitx5configtool-plugin (5.0.17) unstable; urgency=medium

  * load translations in dde-control-center 

 -- zsien <quezhiyong@uniontech.com>  Fri, 05 May 2023 10:07:55 +0800

deepin-fcitx5configtool-plugin (5.0.16) unstable; urgency=medium

  * fix the actions in the list are displayed incorrectly
  * fix missing line splitter for enabled language

 -- zsien <quezhiyong@uniontech.com>  Wed, 12 Apr 2023 14:42:13 +0800

deepin-fcitx5configtool-plugin (5.0.15) unstable; urgency=medium

  * Fix actions are not displayed when hovering
  * Fix open advanced setting page block
  * Improve keyboard layout indication
  * Refactor the pages

 -- zsien <quezhiyong@uniontech.com>  Tue, 28 Mar 2023 15:48:05 +0800

deepin-fcitx5configtool-plugin (5.0.14) unstable; urgency=medium

  * Fix build failure

 -- zsien <quezhiyong@uniontech.com>  Mon, 20 Feb 2023 17:08:22 +0800

deepin-fcitx5configtool-plugin (5.0.13) unstable; urgency=medium

  * 修复输入方式设置页面按钮没翻译

 -- zsien <quezhiyong@uniontech.com>  Fri, 17 Feb 2023 16:26:44 +0800

deepin-fcitx5configtool-plugin (5.0.12) UNRELEASED; urgency=medium

  * Modify the version number

 -- liuchenghao <liuchenghao@uniontech.com>  Feb, 1 Wed 2023 14:50:01 +0800

 deepin-fcitx5configtool-plugin (5.0.11) UNRELEASED; urgency=medium

  * Increase the translation

 -- liuchenghao <liuchenghao@uniontech.com>  Mon, 30 Jan 2023 19:26:01 +0800

deepin-fcitx5configtool-plugin (5.0.10) UNRELEASED; urgency=medium

  * Increase the specified component functions

 -- liuchenghao <liuchenghao@uniontech.com>  Tue, 3 Jan 2023 17:34:20 +0800

deepin-fcitx5configtool-plugin (5.0.9) UNRELEASED; urgency=medium

  * Adaptive dde control center

 -- liuchenghao <liuchenghao@uniontech.com>  Fri, 30 Dec 2022 09:34:20 +0800

deepin-fcitx5configtool-plugin (5.0.8) UNRELEASED; urgency=medium

  * fix bug

 -- yaoyongjie <yaoyongjie@uniontech.com>  Mon, 14 Nov 2022 17:34:20 +0000

deepin-fcitx5configtool-plugin (5.0.7) UNRELEASED; urgency=medium

  * fix bug

 -- guonafu <guonafu@uniontech.com>  Fri, 14 Oct 2022 02:12:43 +0000

deepin-fcitx5configtool-plugin (5.0.6) unstable; urgency=medium

  * 修改遗留bug

 -- zhaoyue <zhaoyue@uniontech.com>  Wed, 15 Jun 2022 16:51:52 +0000

deepin-fcitx5configtool-plugin (5.0.1) unstable; urgency=medium

  * Initial Release.

 -- liuwenhao <liuwenhao@uniontech.com>  Wed, 13 Jan 2021 09:26:45 +0800

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_KCM=Off

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

override_dh_missing:
	dh_missing --list-missing

## deepin-fcitx5configtool-plugin 5.0.24

=== src/lib/configlib/CMakeLists.txt ===
add_library(configlib STATIC
    iso639.cpp
    dbusprovider.cpp
    model.cpp
    addonmodel.cpp
    imconfig.cpp
    logging.cpp
    font.cpp
    layoutmodel.cpp
    layoutprovider.cpp
    xkbrules.cpp
    xkbrules.h
)
set_target_properties(configlib PROPERTIES
    POSITION_INDEPENDENT_CODE TRUE
    AUTOMOC TRUE
    AUTOUIC TRUE
    AUTOUIC_OPTIONS "-tr=fcitx::tr2fcitx;--include=fcitxqti18nhelper.h"
)
target_include_directories(configlib INTERFACE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(configlib Qt5::Core Qt5::Gui Dtk::Core Dtk::Widget Fcitx5Qt5::DBusAddons Fcitx5::Core Fcitx5::Utils)

=== debian/changelog ===
deepin-fcitx5configtool-plugin (5.0.24) unstable; urgency=medium

  * feat: 输入法管理中应不允许删除所有输入法,至少需要保留一个输入法 (#45)

 -- Yutao Meng <mengyutao@deepin.org>  Thu, 26 Sep 2024 13:35:45 +0800

=== debian/control ===
Source: deepin-fcitx5configtool-plugin
Priority: optional
Section: utils
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
 cmake,
 dde-control-center-dev,
 debhelper-compat (= 13),
 extra-cmake-modules,
 gettext,
 iso-codes,
 libdtkcore-dev,
 libdtkwidget-dev,
 libfcitx5-qt-dev (>= 5.1),
 libfcitx5core-dev (>= 5.1),
 libfcitx5utils-dev (>= 5.1),
 libkf5coreaddons-dev,
 libkf5declarative-dev,
 libkf5i18n-dev,
 libkf5package-dev,
 libkf5plasma-dev,
 libqt5svg5-dev,
 libqt5x11extras5-dev,
 libxkbcommon-dev,
 libxkbfile-dev,
 pkg-config,
 qtbase5-dev (>= 5.12),
 qtquickcontrols2-5-dev,
 qttools5-dev,
 xkb-data,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/fcitx/fcitx5-configtool
Vcs-Git: https://salsa.debian.org/input-method-team/fcitx5-configtool.git
Vcs-Browser: https://salsa.debian.org/input-method-team/fcitx5-configtool

Package: deepin-fcitx5configtool-plugin
Architecture: any
Depends:
  ${shlibs:Depends},
  ${misc:Depends},
  fcitx5-module-xorg,
Description: New Fcitx Configtool for Deepin Desktop Environment - development files
 Deepin Fcitxconfigtool Plugin is DDE Control Center plugin for Config Fcitx.

## deepin-fcitx5configtool-plugin 6.0.8

=== debian/changelog ===
deepin-fcitx5configtool-plugin (6.0.8) unstable; urgency=medium

  * bump version to 6.0.8.
  * Add fcitx5-helper executable and desktop entry.

 -- Wang Yu <wangyu@uniontch.com>  Tue, 13 May 2025 15:36:29 +0800

deepin-fcitx5configtool-plugin (6.0.7) unstable; urgency=medium

  * bump version to 6.0.7
  * Fix translations for dde control center plugin.

 -- re2zero <yangwu@uniontech.com>  Fri, 28 Mar 2025 14:18:19 +0800

deepin-fcitx5configtool-plugin (6.0.6) unstable; urgency=medium

  * bump version to 6.0.6
  * Merge Qt5 and Qt6 build.

 -- re2zero <yangwu@uniontech.com>  Thu, 27 Mar 2025 13:25:42 +0800

deepin-fcitx5configtool-plugin (6.0.5) unstable; urgency=medium

  * fix: adjust spacing between labels in AdvancedSettingsModule
  * fix: update input method settings icon name
  * fix: update font styling and parent-child relationships in QML files
  * fix: adapt input method icon for dark theme mode
  * fix: add rounded corners to input method items

 -- Wang Yu <wangyu@uniontch.com>  Thu, 20 Mar 2025 18:53:11 +0800

deepin-fcitx5configtool-plugin (6.0.4) unstable; urgency=medium

  * feat: implement drag-and-drop reordering for input method list
  * fix: [ui] Text not aligned with checkbox

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 02 Jan 2025 19:50:00 +0800

deepin-fcitx5configtool-plugin (6.0.3) unstable; urgency=medium

  * fix bugs

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 13 Dec 2024 17:28:23 +0800

deepin-fcitx5configtool-plugin (6.0.2) unstable; urgency=medium

  * update version.
  * feat: add description for input method settings and update translations
  * fix: improve input method settings UI and translations

 -- Wang Yu <wangyu@uniontch.com>  Sat, 07 Dec 2024 15:55:56 +0800

deepin-fcitx5configtool-plugin (6.0.1) unstable; urgency=medium

  * update version
  * add QML feature

 -- Liu zheng <liuzheng@uniontech.com>  Thu, 28 Nov 2024 15:19:49 +0800

## deepin-fcitx5configtool-plugin 6.0.12

=== debian/changelog ===
deepin-fcitx5configtool-plugin (6.0.12) unstable; urgency=medium

  * fix bugs

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 27 Jun 2025 17:32:22 +0800

deepin-fcitx5configtool-plugin (6.0.11) unstable; urgency=medium

  * chore: update translations (#95)

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Mon, 23 Jun 2025 13:51:08 +0800

deepin-fcitx5configtool-plugin (6.0.10) unstable; urgency=medium

  * fix ui bug

 -- Zhang Sheng <zhangsheng@uniontech.com>  Wed, 18 Jun 2025 17:00:15 +0800

deepin-fcitx5configtool-plugin (6.0.9) unstable; urgency=medium

  * bump version to 6.0.9.
  * chore: [log]More logs.
  * fix: update InputMethodsChooser UI for better readability.

 -- Wang Yu <wangyu@uniontch.com>  Thu, 12 Jun 2025 20:22:27 +0800

## deepin-fcitx5configtool-plugin 6.0.13

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)

set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
set(CMAKE_DISABLE_SOURCE_CHANGES ON)

if ("${CMAKE_BINARY_DIR}" STREQUAL "${CMAKE_SOURCE_DIR}")
  message(FATAL_ERROR "In-source builds are disabled.
    Please create a subfolder and use `cmake ..` inside it.
    NOTE: cmake will now create CMakeCache.txt and CMakeFiles/*.
          You must delete them, or cmake will refuse to work.")
endif()

project(fcitx5-configtool VERSION 5.1.2)

find_package(ECM 1.0.0 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})
include(FeatureSummary)
include(ECMSetupVersion)
include(GenerateExportHeader)
option(ENABLE_CONFIG_QT "Enable fcitx5-config-qt" On)
option(ENABLE_TEST "Enable test" Off)
add_definitions(-DTRANSLATION_DOMAIN=\"org.fcitx.fcitx5.kcm\")
add_definitions(-DFCITX_GETTEXT_DOMAIN=\"fcitx5-configtool\")
add_definitions(-DQT_NO_KEYWORDS)

# Find Qt version
find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
message("   >>> Found Qt version: ${QT_VERSION_MAJOR}")
set(QT_DESIRED_VERSION ${QT_VERSION_MAJOR})

if (QT_VERSION_MAJOR MATCHES 6)
    set(DTK_VERSION_MAJOR 6)
    set(KF_VERSION_MAJOR 6)
else()
    set(DTK_VERSION_MAJOR "")
    set(KF_VERSION_MAJOR 5)
endif()
message("   >>> Build with DTK: ${DTK_VERSION_MAJOR}")

find_package(Fcitx5Core 5.0.4 REQUIRED)
find_package(Fcitx5Config REQUIRED)
find_package(Fcitx5Utils REQUIRED)

find_package(IsoCodes REQUIRED)

include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")

find_package(PkgConfig REQUIRED)
find_package(Gettext REQUIRED)
find_package(X11 REQUIRED)
find_package(XKeyboardConfig REQUIRED)
pkg_check_modules(XkbFile "xkbfile" REQUIRED IMPORTED_TARGET)

set(DEFAULT_XKB_RULES "evdev" CACHE STRING "Xkb rules name")

if (QT_DESIRED_VERSION MATCHES 6)
  add_subdirectory(src)
else()
  add_subdirectory(src-old)
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src-old/CMakeLists.txt ===
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings)
option(ENABLE_KCM "Enable KDE Config Module" On)

set(QT_MIN_VERSION "5.12.0")

find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS Core Gui Widgets X11Extras Concurrent)
find_package(DtkCore REQUIRED)
find_package(DtkWidget REQUIRED)

find_package(KF5ItemViews REQUIRED)

find_package(Fcitx5Qt5DBusAddons REQUIRED)
find_package(Fcitx5Qt5WidgetsAddons 5.0.2 REQUIRED)
find_package(Qt5Svg)
set_package_properties(Qt5Svg PROPERTIES
    DESCRIPTION "May be used for show icons"
    TYPE RUNTIME)

get_target_property(FCITX5_QT5_GUI_WRAPPER Fcitx5Qt5::gui-wrapper IMPORTED_LOCATION)

find_package(KF5WidgetsAddons REQUIRED)
kde_enable_exceptions()

configure_file(config.h.in config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(layout)

# 创建 usr/libexec 目录，规避打包时安装错误
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_PREFIX}/libexec)

=== src-old/po/CMakeLists.txt ===
add_subdirectory(fcitx5-configtool)

=== src/dcc-fcitx5configtool/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(PLUGIN_NAME "dcc-fcitx5configtool")

project(${PLUGIN_NAME})

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall")

# 增加安全编译参数
ADD_DEFINITIONS("-fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

find_package(Qt${QT_DESIRED_VERSION} COMPONENTS Core Gui DBus LinguistTools Qml REQUIRED)
find_package(DdeControlCenter REQUIRED)
find_package(Dtk${DTK_VERSION_MAJOR} COMPONENTS Core REQUIRED)
find_package(PkgConfig REQUIRED)


set(DccFcitx5configtool_Name fcitx5configtool)
file(GLOB_RECURSE DccFcitx5configtool_SRCS
        "operation/qrc/*.qrc"
        "*.cpp"
        "*.h"
        "private/*.h"
        "operation/*.cpp"
        "operation/*.h"
)

add_library(${DccFcitx5configtool_Name} MODULE
        ${DccFcitx5configtool_SRCS}
)

target_include_directories(${DccFcitx5configtool_Name} PUBLIC
    Dde::Control-Center
    configlib${QT_DESIRED_VERSION}
    configwidgetslib${QT_DESIRED_VERSION}
)

set(DccFcitx5configtool_Libraries
        Qt${QT_DESIRED_VERSION}::DBus
        Qt${QT_DESIRED_VERSION}::Gui
        Qt${QT_DESIRED_VERSION}::Qml
        Dtk${DTK_VERSION_MAJOR}::Core
        Dde::Control-Center
)

target_link_libraries(${DccFcitx5configtool_Name} PRIVATE
        ${DccFcitx5configtool_Libraries}
        configlib${QT_DESIRED_VERSION}
        configwidgetslib${QT_DESIRED_VERSION}
)

dcc_install_plugin(NAME ${DccFcitx5configtool_Name} TARGET ${DccFcitx5configtool_Name})
dcc_handle_plugin_translation(NAME ${DccFcitx5configtool_Name})

=== src/fcitx5helper/CMakeLists.txt ===
set(BIN_NAME fcitx5-helper)

if (CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "mips64")
    option(USE_MIPS64 "USE MIPS64" ON)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -Wl,-O1 -Wl,--as-needed -Wl,-E -fPIE -ffunction-sections -fdata-sections -Wl,--gc-sections -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -z noexecstack")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O3 -Wl,-O1 -Wl,--as-needed -Wl,-E -fPIE -ffunction-sections -fdata-sections -Wl,--gc-sections -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions -mloongson-ext2 -mloongson-mmi -z noexecstack")
    SET(CMAKE_EXE_LINKER_FLAGS  "-pie")
endif()

if (CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra -pthread")
  # Enable Qt builtin debug mode
  add_definitions("-DQT_MESSAGELOGCONTEXT -std=c++11")
else()
  # -Wl, -O2 Enable linker optimizations
  # -Wl, --gc-sections Remove unused code resulting from -fdsta-sections and
  # -ffunction-sections
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2 -Wl,--gc-sections")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2 -Wl,--gc-sections -pthread")
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD 17)

find_package(PkgConfig REQUIRED)
find_package(Qt${QT_DESIRED_VERSION} COMPONENTS Core REQUIRED)

add_executable(${BIN_NAME}
        ${CMAKE_CURRENT_SOURCE_DIR}/processmonitor.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
        )

target_link_libraries(${BIN_NAME}
        Qt${QT_DESIRED_VERSION}::Core
        )

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

install(TARGETS ${BIN_NAME} DESTINATION /usr/bin/)
install(FILES fcitx5-helper.desktop DESTINATION /etc/xdg/autostart/)

=== src-old/src/dcc-fcitx5configtool/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(PLUGIN_NAME "deepin-fcitx5configtool-plugin")

project(${PLUGIN_NAME})

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall")

# 增加安全编译参数
ADD_DEFINITIONS("-fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

# 指定要用到的库
# -DQT_MAJOR_VERSION=6
# find_package(QT NAMES Qt6 Qt5)
# set(QT_MAJOR_VERSION 6)
# set(QT_DEFAULT_MAJOR_VERSION 6)
find_package(Qt6 COMPONENTS Core Gui DBus LinguistTools REQUIRED)
find_package(DdeControlCenter REQUIRED)
find_package(Dtk6 COMPONENTS Core REQUIRED)
find_package(PkgConfig REQUIRED)


set(DccFcitx5configtool_Name fcitx5configtool)
file(GLOB_RECURSE DccFcitx5configtool_SRCS
        "*.cpp"
        "*.h"
        "operation/*.cpp"
        "operation/*.h"
)

add_library(${DccFcitx5configtool_Name} MODULE
        ${DccFcitx5configtool_SRCS}
)

target_include_directories(${DccFcitx5configtool_Name} PUBLIC
    Dde::Control-Center
)

set(DccFcitx5configtool_Libraries
        Qt6::DBus
        Qt6::Gui
        Dtk6::Core
        Dde::Control-Center
)

target_link_libraries(${DccFcitx5configtool_Name} PRIVATE
        ${DccFcitx5configtool_Libraries}
)

dcc_install_plugin(NAME ${DccFcitx5configtool_Name} TARGET ${DccFcitx5configtool_Name})

=== debian/changelog ===
deepin-fcitx5configtool-plugin (6.0.13) unstable; urgency=medium

  * update translations.

 -- Liuyangming <liuyangming@uniontech.com>  Thu, 03 Jul 2025 16:05:42 +0800

=== debian/control ===
--- 
+++ 
@@ -9,24 +9,21 @@
  extra-cmake-modules,
  gettext,
  iso-codes,
- libdtkcore-dev,
- libdtkwidget-dev,
- libfcitx5-qt-dev (>= 5.1),
+ qt6-5compat-dev | libqt5x11extras5-dev,
+ qt6-base-dev | qtbase5-dev (>= 5.12),
+ qt6-declarative-dev | qtquickcontrols2-5-dev,
+ qt6-tools-dev | qttools5-dev,
+ qt6-svg-dev | libqt5svg5-dev,
+ libdtk6core-dev | libdtkcore-dev,
+ libdtk6widget-dev | libdtkwidget-dev,
+ libfcitx5-qt6-dev (>= 5.1.4) | libfcitx5-qt-dev (>= 5.1),
  libfcitx5core-dev (>= 5.1),
  libfcitx5utils-dev (>= 5.1),
- libkf5coreaddons-dev,
- libkf5declarative-dev,
- libkf5i18n-dev,
- libkf5package-dev,
- libkf5plasma-dev,
- libqt5svg5-dev,
- libqt5x11extras5-dev,
+ libkf6widgetsaddons-dev | libkf5widgetsaddons-dev,
+ libkf6itemviews-dev | libkf5itemviews-dev,
  libxkbcommon-dev,
  libxkbfile-dev,
  pkg-config,
- qtbase5-dev (>= 5.12),
- qtquickcontrols2-5-dev,
- qttools5-dev,
  xkb-data,
 Standards-Version: 4.6.2
 Rules-Requires-Root: no

## deepin-fcitx5configtool-plugin 6.0.16

=== debian/changelog ===
deepin-fcitx5configtool-plugin (6.0.16) unstable; urgency=medium

  * fix: resolve naming conflicts and add loading state in QML components.

 -- Wang Yu <wangyu@uniontch.com>  Fri, 08 Aug 2025 15:37:25 +0800

deepin-fcitx5configtool-plugin (6.0.15) unstable; urgency=medium

  * chore: Add new Lao translation file

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 07 Aug 2025 17:47:09 +0800

deepin-fcitx5configtool-plugin (6.0.14) unstable; urgency=medium

  * add single instance lock mechanism for fcitx5-helper

 -- Wang Yu <wangyu@uniontch.com>  Thu, 31 Jul 2025 16:36:51 +0800

## deepin-fcitx5configtool-plugin 6.0.19

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall")

# 增加安全编译参数
ADD_DEFINITIONS("-fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

find_package(Qt${QT_DESIRED_VERSION} COMPONENTS Core Gui DBus LinguistTools REQUIRED)
find_package(Dtk${DTK_VERSION_MAJOR} COMPONENTS Core Widget REQUIRED)


include(GNUInstallDirs)
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif()

if(NOT DEFINED CONFIGTOOL_EXEC_DIR)
    set(CONFIGTOOL_EXEC_DIR ${CMAKE_INSTALL_LIBEXECDIR})
endif()

add_definitions(-DDCC_CONFIGTOOL_EXEC_PATH=\"${CONFIGTOOL_EXEC_DIR}\")

add_subdirectory(lib)
add_subdirectory(dcc-fcitx5configtool)
add_subdirectory(dcc-fcitx5configtool-exec)
add_subdirectory(fcitx5helper)

=== src-old/layout/CMakeLists.txt ===
add_library(X11Import UNKNOWN IMPORTED)
set_target_properties(X11Import PROPERTIES
    IMPORTED_LOCATION "${X11_X11_LIB}"
    INTERFACE_INCLUDE_DIRECTORIES "${X11_X11_INCLUDE_PATH}")

add_library(X11XkblibImport INTERFACE IMPORTED)
set_target_properties(X11XkblibImport PROPERTIES
    INTERFACE_INCLUDE_DIRECTORIES "${X11_Xkblib_INCLUDE_PATH}")

add_library(layoutlib STATIC keyboardlayoutwidget.cpp)
set_target_properties(layoutlib PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
target_link_libraries(layoutlib PUBLIC Fcitx5::Utils Qt5::Widgets PRIVATE Qt5::X11Extras X11Import X11XkblibImport PkgConfig::XkbFile)
target_include_directories(layoutlib INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})

set(kbd_layout_viewer_SOURCES
  main.cpp
  )

add_executable(kbd-layout-viewer5 ${kbd_layout_viewer_SOURCES})

target_link_libraries(kbd-layout-viewer5 Fcitx5::Utils Qt5::Widgets Qt5::X11Extras layoutlib)

install(TARGETS kbd-layout-viewer5 DESTINATION ${KDE_INSTALL_BINDIR})
fcitx5_translate_desktop_file(
  kbd-layout-viewer5.desktop.in
  kbd-layout-viewer5.desktop PO_DIRECTORY ${PROJECT_SOURCE_DIR}/po/fcitx5-configtool)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/kbd-layout-viewer5.desktop"
  DESTINATION ${KDE_INSTALL_APPDIR})

=== src-old/src/CMakeLists.txt ===
add_subdirectory(lib)
add_subdirectory(dcc-module)

=== src/dcc-fcitx5configtool-exec/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

set(BIN_NAME "dcc-fcitx5configtool-exec")

project(${BIN_NAME})

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "-g -Wall")

# 增加安全编译参数
ADD_DEFINITIONS("-fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

# 指定要用到的库
find_package(Qt${QT_DESIRED_VERSION} COMPONENTS Core Gui Widgets REQUIRED)
find_package(Fcitx5Qt${QT_DESIRED_VERSION}DBusAddons REQUIRED)

file(GLOB_RECURSE DccFcitx5configtool_SRCS
    "*.cpp"
    "*.h"
)

add_executable(${BIN_NAME}
    ${DccFcitx5configtool_SRCS}
)

set(DccFcitx5configtool_Libraries
        Qt${QT_DESIRED_VERSION}::Gui
        Qt${QT_DESIRED_VERSION}::Widgets
        Dtk${DTK_VERSION_MAJOR}::Core
)

target_link_libraries(${BIN_NAME} PRIVATE
        ${DccFcitx5configtool_Libraries}
        configlib${QT_DESIRED_VERSION}
        configwidgetslib${QT_DESIRED_VERSION}
        Fcitx5Qt${QT_DESIRED_VERSION}::DBusAddons
)

target_include_directories(${BIN_NAME}
    PRIVATE
    ${CMAKE_SOURCE_DIR}/src/lib/configwidgetslib
)

message(STATUS "Install ${BIN_NAME} to ${CONFIGTOOL_EXEC_DIR}")
message(STATUS "CONFIGTOOL_EXEC_DIR=${CONFIGTOOL_EXEC_DIR}")
install(TARGETS ${BIN_NAME} DESTINATION ${CONFIGTOOL_EXEC_DIR})

=== src/dcc-fcitx5configtool/CMakeLists.txt ===
--- 
+++ 
@@ -17,16 +17,24 @@
 find_package(DdeControlCenter REQUIRED)
 find_package(Dtk${DTK_VERSION_MAJOR} COMPONENTS Core REQUIRED)
 find_package(PkgConfig REQUIRED)
+find_package(PolkitQt6-1 REQUIRED)
+find_package(PkgConfig REQUIRED)
+pkg_check_modules(ICU REQUIRED icu-uc icu-i18n)
 
 
 set(DccFcitx5configtool_Name fcitx5configtool)
 file(GLOB_RECURSE DccFcitx5configtool_SRCS
         "operation/qrc/*.qrc"
+        "keyboard-layout/operation/qrc/*.qrc"
         "*.cpp"
         "*.h"
+        "*.qml"
         "private/*.h"
         "operation/*.cpp"
         "operation/*.h"
+        "keyboard-layout/operation/*.cpp"
+        "keyboard-layout/operation/*.h"
+        "keyboard-layout/qml/*.qml"
 )
 
 add_library(${DccFcitx5configtool_Name} MODULE
@@ -37,6 +45,8 @@
     Dde::Control-Center
     configlib${QT_DESIRED_VERSION}
     configwidgetslib${QT_DESIRED_VERSION}
+    keyboard-layout/operation
+    ${ICU_INCLUDE_DIRS}
 )
 
 set(DccFcitx5configtool_Libraries
@@ -45,6 +55,8 @@
         Qt${QT_DESIRED_VERSION}::Qml
         Dtk${DTK_VERSION_MAJOR}::Core
         Dde::Control-Center
+        PolkitQt6-1::Agent
+        ${ICU_LIBRARIES}
 )
 
 target_link_libraries(${DccFcitx5configtool_Name} PRIVATE

=== src/fcitx5helper/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra -pthread")
   # Enable Qt builtin debug mode
-  add_definitions("-DQT_MESSAGELOGCONTEXT -std=c++11")
+  add_definitions("-DQT_MESSAGELOGCONTEXT")
 else()
   # -Wl, -O2 Enable linker optimizations
   # -Wl, --gc-sections Remove unused code resulting from -fdsta-sections and

=== src/lib/CMakeLists.txt ===
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings)
option(ENABLE_KCM "Enable KDE Config Module" On)

find_package(Fcitx5Qt${QT_DESIRED_VERSION}DBusAddons REQUIRED)
find_package(Fcitx5Qt${QT_DESIRED_VERSION}WidgetsAddons REQUIRED)
find_package(KF${KF_VERSION_MAJOR}ItemViews REQUIRED)
find_package(KF${KF_VERSION_MAJOR}WidgetsAddons REQUIRED)
kde_enable_exceptions()

configure_file(config.h.in config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(layout)
add_subdirectory(configlib)
add_subdirectory(configwidgetslib)

=== src-old/src/dcc-module/CMakeLists.txt ===
find_package(Qt5 COMPONENTS LinguistTools REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(DdeControlCenter REQUIRED)

pkg_check_modules(xkbcommon REQUIRED IMPORTED_TARGET xkbcommon)

file(GLOB TS_FILES "translations/*.ts")
qt_add_translation(QM_FILES ${TS_FILES})
add_custom_target(translations ALL DEPENDS ${QM_FILES})

add_library(dcc-fcitx5configtool-plugin SHARED
    fcitx5configplugin.cpp
    fcitx5configplugin.h
    addimpage.cpp
    addimpage.h
    imsettingwindow.cpp
    imsettingwindow.h
    imwindow.cpp
    imwindow.h
    layoutwidget.cpp
    layoutwidget.h
    configproxy.cpp
    configproxy.h

    widgets/utils.h
    widgets/contentwidget.cpp
    widgets/contentwidget.h
    widgets/keylabel.h
    widgets/keysettingsitem.cpp
    widgets/keysettingsitem.h

    widgets/labels/clicklabel.cpp
    widgets/labels/clicklabel.h
    widgets/labels/largelabel.h
    widgets/labels/normallabel.h
    widgets/labels/shortenlabel.cpp
    widgets/labels/shortenlabel.h
    widgets/labels/smalllabel.h
    widgets/labels/tipslabel.h

    res/dcc-module.qrc
)

set_target_properties(dcc-fcitx5configtool-plugin
    PROPERTIES
    AUTOMOC TRUE
    AUTORCC TRUE
    AUTOUIC TRUE
    AUTOUIC_OPTIONS "-tr=fcitx::tr2fcitx;--include=fcitxqti18nhelper.h")

target_link_libraries(dcc-fcitx5configtool-plugin
    Dtk::Core
    Dtk::Widget
    Dde::DCCInterface
    Dde::DCCWidget
    PkgConfig::xkbcommon
    configwidgetslib
)

# 设置执行 make install 时哪个目标应该被 install 到哪个位置
install(TARGETS dcc-fcitx5configtool-plugin LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/dde-control-center/modules)

# 安装 .qm 文件
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dde-control-center/translations)

=== src-old/src/lib/CMakeLists.txt ===
add_subdirectory(configlib)
add_subdirectory(configwidgetslib)

=== src-old/src/plasmathemegenerator/CMakeLists.txt ===
add_executable(fcitx5-plasma-theme-generator main.cpp)

message(WARNING "Plasma theme generator: depends libkf5plasma-dev libkf5i18n-dev")
find_package(KF5Plasma REQUIRED)
find_package(KF5IconThemes REQUIRED)
find_package(KF5I18n REQUIRED)

target_link_libraries(fcitx5-plasma-theme-generator KF5::Plasma KF5::IconThemes KF5::I18n Fcitx5::Utils Fcitx5::Config)

install(TARGETS fcitx5-plasma-theme-generator DESTINATION ${CMAKE_INSTALL_BINDIR})

=== src/lib/configlib/CMakeLists.txt ===
set(PLUGIN_NAME "configlib${QT_DESIRED_VERSION}")

add_library(${PLUGIN_NAME} STATIC
    iso639.cpp
    dbusprovider.cpp
    model.cpp
    addonmodel.cpp
    imconfig.cpp
    logging.cpp
    font.cpp
    layoutmodel.cpp
    layoutprovider.cpp
    xkbrules.cpp
    xkbrules.h
)
set_target_properties(${PLUGIN_NAME} PROPERTIES
    POSITION_INDEPENDENT_CODE TRUE
    AUTOMOC TRUE
    AUTOUIC TRUE
    AUTOUIC_OPTIONS "-tr=fcitx::tr2fcitx;--include=fcitxqti18nhelper.h"
)
target_include_directories(${PLUGIN_NAME} INTERFACE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(${PLUGIN_NAME}
    Qt${QT_DESIRED_VERSION}::Core
    Qt${QT_DESIRED_VERSION}::Gui
    Dtk${DTK_VERSION_MAJOR}::Core
    Dtk${DTK_VERSION_MAJOR}::Widget
    Fcitx5Qt${QT_DESIRED_VERSION}::DBusAddons
    Fcitx5::Core Fcitx5::Utils)

=== src/lib/configwidgetslib/CMakeLists.txt ===
set(PLUGIN_NAME "configwidgetslib${QT_DESIRED_VERSION}")

add_library(${PLUGIN_NAME} STATIC
    configwidget.cpp
    addonselector.cpp
    categoryhelper.cpp
    erroroverlay.cpp
    fontbutton.cpp
    keylistwidget.cpp
    layoutselector.cpp
    listoptionwidget.cpp
    optionwidget.cpp
    varianthelper.cpp
    verticalscrollarea.cpp
    impage.cpp
)

set_target_properties(${PLUGIN_NAME} PROPERTIES
    POSITION_INDEPENDENT_CODE TRUE
    AUTOMOC TRUE
    AUTOUIC TRUE
    AUTOUIC_OPTIONS "-tr=fcitx::tr2fcitx;--include=fcitxqti18nhelper.h"
)

target_include_directories(${PLUGIN_NAME} INTERFACE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(${PLUGIN_NAME}
    Qt${QT_DESIRED_VERSION}::Core
    Qt${QT_DESIRED_VERSION}::Widgets
    KF${KF_VERSION_MAJOR}::WidgetsAddons
    KF${KF_VERSION_MAJOR}::ItemViews
    Fcitx5::Utils
    Fcitx5Qt${QT_DESIRED_VERSION}::DBusAddons
    Fcitx5Qt${QT_DESIRED_VERSION}::WidgetsAddons
    configlib${QT_DESIRED_VERSION}
    layoutlib${QT_DESIRED_VERSION})

=== debian/changelog ===
deepin-fcitx5configtool-plugin (6.0.19) unstable; urgency=medium

  * fix: add Lao translation file & font alignment issue

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Sat, 11 Oct 2025 09:47:03 +0800

deepin-fcitx5configtool-plugin (6.0.18) unstable; urgency=medium

  * feat: enhance shortcut configuration in QML
  * feat: integrate keyboard layout module and enhance configuration

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Tue, 23 Sep 2025 19:15:41 +0800

deepin-fcitx5configtool-plugin (6.0.17) unstable; urgency=medium

  * fix: update translations of fr

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 18 Sep 2025 19:29:59 +0800

=== debian/control ===
--- 
+++ 
@@ -23,6 +23,8 @@
  libkf6itemviews-dev | libkf5itemviews-dev,
  libxkbcommon-dev,
  libxkbfile-dev,
+ libicu-dev,
+ libpolkit-qt6-1-dev,
  pkg-config,
  xkb-data,
 Standards-Version: 4.6.2

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# 检测当前安装的Qt版本，优先使用Qt6，否则使用Qt5
define detect_qt_version
ifneq (,$(shell which qmake6 2>/dev/null))
    QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt6"
else
    QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt5"
endif
endef

# 调用检测Qt版本的命令
$(eval $(call detect_qt_version))

# hardcode this if want to force build with sepecific Qt version
# QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt5"

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DENABLE_KCM=Off \
	-DCMAKE_BUILD_TYPE=Release \
	-DQT_DIR=$(QT_DIR)

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

override_dh_missing:
	dh_missing --list-missing

## deepin-fcitx5configtool-plugin 6.0.21

=== debian/changelog ===
deepin-fcitx5configtool-plugin (6.0.21) unstable; urgency=medium

  * chore: comment out debug logs in ProcessMonitor

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 20 Nov 2025 20:00:59 +0800

deepin-fcitx5configtool-plugin (6.0.20) unstable; urgency=medium

  * fix: Update translation files.

 -- dengzhongyuan <dengzhongyuan@uniontech.com>  Thu, 23 Oct 2025 19:11:45 +0800
